#ifndef	DEF_GRID
#define	DEF_GRID

/* Grid.h
 * Defines the class Grid
 * A grid contains a table of cells the game will be set on
 * Creators : krilius, manzerbredes
 * Date : 29/04/2015 */

#include <iostream>
#include <sstream>
#include <vector>
#include <tuple>

class Grid
{
	private:
		int m_size;
		std::vector<std::vector<int> > m_grid;

		int m_lastMoveScore;

		int maxStrLenInGrid();

	public:
		Grid();
		~Grid();

		std::string description();
		bool isEmpty(int i, int j);
		std::tuple<int, int> getRandomEmptyCellCoord();

		bool setCell(std::tuple<int, int> coord, int value);
		bool setCell(int i, int j, int value);

		std::vector<int> swipeLine(std::vector<int> line);
		std::vector<int> rightDefragment(std::vector<int> line);
		std::vector<int> leftDefragment(std::vector<int> line);
		std::vector<int> rightMerge(std::vector<int> line);
		std::vector<int> leftMerge(std::vector<int> line);

		std::vector<int> getCol(int col);

		bool isFull();
		bool isOver();

		void setCol(int col, std::vector<int> colVect);
		std::vector<int> reverseLine(std::vector<int> line);
		bool compareLines(std::vector<int> line1, std::vector<int> line2);

		//Moves
		bool swipeRight();
		bool swipeLeft();
		bool swipeUp();
		bool swipeDown();

		int getLastMoveScore();
};


#endif
